/* Example FOFL functions for arithmetic */

prog
  def add(x:Nat,y:Nat):Nat = if iszero x then y else succ(add(pred x,y))
  def sub(x:Nat,y:Nat):Nat = if iszero y then x else pred(sub(x,pred y))
  def leq(x:Nat,y:Nat):Bool = if iszero(sub(x,y)) then true else false
  def mult(x:Nat,y:Nat):Nat = if iszero x then 0 else add(y,mult(pred x,y))
  def fact(n:Nat):Nat = if iszero n then 1 else mult(n,fact(pred n))
  def div(x:Nat,y:Nat):Nat = ?
  def mod(x:Nat,y:Nat):Nat = ?
  def exp(x:Nat,y:Nat):Nat = ?
gorp

add(3,4);    /* = 7 */
sub(10,6);   /* = 4 */
sub(10,14);  /* = 0 */

leq(0,0);     /* true */
leq(10,20);   /* true */
leq(11,10);   /* false */

mult(3,4);   /* = 12 */
mult(10,5);  /* = 50.*/

fact(5);     /* = 120. Anything much larger will get S L O W !! */

div(20,3);   /* = 6 */
mod(20,3);   /* = 2 */
exp(2,4);    /* = 16 */

/* Quick exercises: fill in definitions for div(), mod(), exp() */


